//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Son_Of_Earth"

#property indicator_separate_window
#property indicator_buffers 8
#property strict
//---
#property indicator_color1 clrDarkTurquoise
#property indicator_color2 clrRed
#property indicator_color3 clrBlue
#property indicator_color4 clrCoral
#property indicator_color5 clrCoral
#property indicator_color6 clrYellowGreen
#property indicator_color7 clrMediumTurquoise
#property indicator_color8 clrMediumTurquoise
//---
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1

//---
#define oComment  "spreadParam"             //   

//--- input
input string   InpSymbol1     =  "EURUSD";   //  BUY
input string   InpSymbol2     =  "GBPUSD";   //  SELL
input double   InpVolume1     =  2;          //   BUY
input double   InpVolume2     =  1;          //   SELL
input bool     InpShowBidAsk  =  false;      //   -
input bool     InpShowEnv     =  true;       //  
input bool     InpEquityScale =  true;       //   
input uint     InpEnvPeriod   =  21;         //   
input double   InpEnvDev      =  0.1;        //    
input double   InpAlertBidMore=  EMPTY;      //  ,    
input double   InpAlertAskLess=  EMPTY;      //  ,    

//--- buffers
double Last[];
double _Ask[];
double _Bid[];
double EnvUp2[];
double EnvUp1[];
double MA[];
double EnvDn1[];
double EnvDn2[];
//--- global variables
int soundCount;
double Symbol1_K,Symbol2_K;
string sname;
string err_str;
double _ask,_bid;
string Symbol1,Symbol2;
//+------------------------------------------------------------------+
//|   OnInit                                                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   Symbol1 = InpSymbol1;
   Symbol2 = InpSymbol2;
   if(InpSymbol1=="")Symbol1 = _Symbol;
   if(InpSymbol2=="")Symbol2 = _Symbol;

   err_str="";
//---  1
   if(MarketInfo(Symbol1,MODE_POINT)==0.0)
     {
      err_str="Unknown symbol "+Symbol1;
      return(INIT_SUCCEEDED);
     }

//---  2
   if(MarketInfo(Symbol2,MODE_POINT)==0.0)
     {
      err_str="Unknown symbol "+Symbol2;
      return(INIT_SUCCEEDED);
     }

//---
   Symbol1_K = 1;
   Symbol2_K = 1;
   if(InpEquityScale)
     {
      Symbol1_K = MarketInfo(Symbol1, MODE_TICKVALUE)/MarketInfo(Symbol1, MODE_TICKSIZE);
      Symbol2_K = MarketInfo(Symbol2, MODE_TICKVALUE)/MarketInfo(Symbol2, MODE_TICKSIZE);
     }

   int StartBar=Bars-fmax(iBarShift(NULL,0,MathMax(iTime(Symbol1,0,iBars(Symbol1,0)-1),iTime(Symbol2,0,iBars(Symbol2,0)-1))),0);
//---
   sname=StringFormat("%.2f*%.0f*%s - %.2f*%.0f*%s",InpVolume1,Symbol1_K,Symbol1,InpVolume2,Symbol2_K,Symbol2);
   if(InpShowEnv) sname=StringFormat("%s(%d,%.2f)",sname,InpEnvPeriod,InpEnvDev);
   Print(StartBar);
//---
   SetIndexShift(0,0);
   SetIndexBuffer(0,Last);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Last");
   SetIndexDrawBegin(0,StartBar);
//---
//if(InpShowBidAsk)
     {
      SetIndexShift(1,0);
      SetIndexBuffer(1,_Ask);
      SetIndexStyle(1,DRAW_LINE);
      SetIndexLabel(1,"Ask");
      SetIndexDrawBegin(1,StartBar);
      //---
      SetIndexShift(2,0);
      SetIndexBuffer(2,_Bid);
      SetIndexStyle(2,DRAW_LINE);
      SetIndexLabel(2,"Bid");
      SetIndexDrawBegin(2,StartBar);
     }
//---
//if(InpShowEnv)
     {
      SetIndexShift(3,0);
      SetIndexBuffer(3,EnvUp2);
      SetIndexStyle(3,DRAW_LINE);
      SetIndexLabel(3,"EnvUp2");
      SetIndexDrawBegin(3,StartBar+InpEnvPeriod);
      //---
      SetIndexShift(4,0);
      SetIndexBuffer(4,EnvUp1);
      SetIndexStyle(4,DRAW_LINE);
      SetIndexLabel(4,"EnvUp1");
      SetIndexDrawBegin(4,StartBar+InpEnvPeriod);
      //---
      SetIndexShift(5,0);
      SetIndexBuffer(5,MA);
      SetIndexStyle(5,DRAW_LINE);
      SetIndexLabel(5,"MA");
      SetIndexDrawBegin(5,StartBar+InpEnvPeriod);
      //---
      SetIndexShift(6,0);
      SetIndexBuffer(6,EnvDn1);
      SetIndexStyle(6,DRAW_LINE);
      SetIndexLabel(6,"EnvDn1");
      SetIndexDrawBegin(6,StartBar+InpEnvPeriod);
      //---
      SetIndexShift(7,0);
      SetIndexBuffer(7,EnvDn2);
      SetIndexStyle(7,DRAW_LINE);
      SetIndexLabel(7,"EnvDn2");
      SetIndexDrawBegin(7,StartBar+InpEnvPeriod);
     }
   soundCount=10;
//---
   IndicatorDigits(Digits);
   if(InpEquityScale)IndicatorDigits(Digits-2);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|   OnDeinit                                                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//|   OnCalculate                                                    |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

//---   
   if(err_str!="")
     {
      DrawLabel(oComment,err_str,8,DarkGray,16);
      return(0);
     }

//--- 
   DrawLabel(oComment,sname,8,DarkGray,16);

   int limit,limit2;
   if(prev_calculated<=0)
     {
      limit=rates_total-1;
      ArrayInitialize(Last,EMPTY_VALUE);
      ArrayInitialize(_Ask,EMPTY_VALUE);
      ArrayInitialize(_Bid,EMPTY_VALUE);
      ArrayInitialize(EnvUp2,EMPTY_VALUE);
      ArrayInitialize(EnvUp1,EMPTY_VALUE);
      ArrayInitialize(MA,EMPTY_VALUE);
      ArrayInitialize(EnvDn1,EMPTY_VALUE);
      ArrayInitialize(EnvDn2,EMPTY_VALUE);
     }
   else
     {
      limit=rates_total-prev_calculated;
      limit2=rates_total-prev_calculated;
     }

   if(InpShowBidAsk)
     {
      double ask1 = InpVolume1*Symbol1_K*MarketInfo(Symbol1,MODE_ASK);
      double bid1 = InpVolume1*Symbol1_K*MarketInfo(Symbol1,MODE_BID);
      double ask2 = InpVolume2*Symbol2_K*MarketInfo(Symbol2,MODE_ASK);
      double bid2 = InpVolume2*Symbol2_K*MarketInfo(Symbol2,MODE_BID);
      _ask = ask1-bid2;
      _bid = bid1-ask2;
     }
//---
   for(int i=limit; i>=0; i--)
     {

      Last[i]=InpVolume1*Symbol1_K*iClose(Symbol1,0,iBarShift(Symbol1,0,time[i])) -
              InpVolume2*Symbol2_K*iClose(Symbol2,0,iBarShift(Symbol2,0,time[i]));
      //---      
      if(InpShowBidAsk)
        {
         _Ask[i]=_ask;
         _Bid[i]=_bid;
        }
     }

//---
   if(InpShowEnv)
     {
      for(int i=limit; i>=0; i--)
         MA[i]=iMAOnArray(Last,0,InpEnvPeriod,0,MODE_SMA,i);

      for(int i=limit; i>=0; i--)
        {
         double main=iMAOnArray(Last,0,InpEnvPeriod,0,MODE_SMA,i);
         EnvUp2[i] = (1+InpEnvDev/100)*main;
         EnvUp1[i] = (1+InpEnvDev/2/100)*main;
         EnvDn1[i] = (1-InpEnvDev/2/100)*main;
         EnvDn2[i] = (1-InpEnvDev/100)*main;
        }
     }

   if(soundCount>0 && 
      ((InpAlertBidMore!=EMPTY && _Bid[0]>InpAlertBidMore) || (InpAlertAskLess!=EMPTY && _Ask[0]<InpAlertAskLess)))
     {
      PlaySound("alert2.wav");
      Print(Symbol1+"-"+Symbol2+": channel width condition is achived");
      soundCount--;
     }
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|   DrawLabel                                                      |
//+------------------------------------------------------------------+
void DrawLabel(string aName,string aText,int aFontSize,color aColor,int aValue)
  {
   int wndNum=WindowFind(WindowExpertName());
   string wndName=WindowExpertName() + IntegerToString(wndNum);
   string objName=aName+wndName;
   if(ObjectFind(0,objName)!=-1 || 
      ObjectCreate(objName,OBJ_LABEL,wndNum,0,0))
     {
      ObjectSetText(objName,aText,aFontSize,"Verdana",aColor);
      ObjectSet(objName,OBJPROP_CORNER,0);
      ObjectSet(objName,OBJPROP_XDISTANCE,4);
      ObjectSet(objName,OBJPROP_YDISTANCE,aValue);
     }
  }
//+------------------------------------------------------------------+
